> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mobilerun.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# List physical eSIMs

> Lists physical eSIMs owned by the authenticated owner.



## OpenAPI

````yaml /api-reference/mobilerun-numbers.yaml get /numbers/esims
openapi: 3.1.0
info:
  title: Mobilerun Numbers
  version: v1
servers:
  - description: Droidrun Cloud API
    url: https://api.mobilerun.ai/v1
security:
  - bearerAuth: []
paths:
  /numbers/esims:
    get:
      tags:
        - Esims
      summary: List physical eSIMs
      description: Lists physical eSIMs owned by the authenticated owner.
      operationId: listEsims
      parameters:
        - in: query
          name: page
          required: false
          schema:
            default: 1
            exclusiveMinimum: 0
            type: integer
        - in: query
          name: pageSize
          required: false
          schema:
            default: 20
            maximum: 100
            minimum: 1
            type: integer
        - in: query
          name: status
          required: false
          schema:
            default: all
            enum:
              - all
              - in_stock
              - owned
              - installing
              - installed
              - install_failed
              - retired
            type: string
        - description: Only include eSIMs created by the calling actor.
          in: query
          name: mine
          required: false
          schema:
            description: Only include eSIMs created by the calling actor.
            enum:
              - 'true'
              - 'false'
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PublicListEsimsResponse'
          description: eSIMs retrieved
        '400':
          description: Bad Request
        '401':
          description: Unauthorized
        '500':
          description: Internal Server Error
        '503':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EsimErrorResponse'
          description: >-
            Service Unavailable — esims are disabled for this deployment (see
            `reason`)
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Mobilerun from '@mobilerun/sdk';

            const client = new Mobilerun({
              apiKey: process.env['MOBILERUN_CLOUD_API_KEY'], // This is the default and can be omitted
            });

            const esims = await client.esims.list();

            console.log(esims.items);
        - lang: Python
          source: |-
            import os
            from mobilerun_sdk import Mobilerun

            client = Mobilerun(
                api_key=os.environ.get("MOBILERUN_CLOUD_API_KEY"),  # This is the default and can be omitted
            )
            esims = client.esims.list()
            print(esims.items)
components:
  schemas:
    PublicListEsimsResponse:
      properties:
        items:
          items:
            $ref: '#/components/schemas/PublicEsim'
          type: array
        pagination:
          $ref: '#/components/schemas/Pagination'
      required:
        - items
        - pagination
      type: object
    EsimErrorResponse:
      properties:
        message:
          type: string
        reason:
          enum:
            - out_of_stock
            - owner_esim_cap
            - byo_disabled
            - byo_esim_cap
            - byo_daily_import_limit
            - byo_failed_limit
            - esim_not_owned
            - device_pool_empty
            - device_claim_cap
            - operator_resolution_required
            - idempotency_conflict
            - byo_awaiting_payment_cap
            - operator_review_required
            - byo_not_reassignable
            - product_disabled
          type: string
        success:
          enum:
            - false
          type: boolean
      required:
        - success
        - reason
        - message
      type: object
    PublicEsim:
      properties:
        cancellationScheduled:
          type: boolean
        carrierName:
          type:
            - string
            - 'null'
        checkoutUrl:
          type:
            - string
            - 'null'
        countryCode:
          type:
            - string
            - 'null'
        createdAt:
          format: date-time
          type:
            - string
            - 'null'
        createdBy:
          type:
            - string
            - 'null'
        currentPeriodEnd:
          format: date-time
          type:
            - string
            - 'null'
        deviceId:
          format: uuid
          type:
            - string
            - 'null'
        deviceUuid:
          type:
            - string
            - 'null'
        exempt:
          type: boolean
        iccid:
          type:
            - string
            - 'null'
        id:
          format: uuid
          type: string
        msisdn:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        networkStatus:
          enum:
            - degraded
            - null
          type:
            - string
            - 'null'
        rentStatus:
          enum:
            - not_applicable
            - exempt
            - inactive
            - awaiting_payment
            - active
            - cancel_pending
            - refund_pending
            - retiring
            - billing_error
          type: string
        source:
          enum:
            - stocked
            - byo
          type: string
        status:
          enum:
            - in_stock
            - owned
            - installing
            - installed
            - install_failed
            - retired
          type: string
        subscriptionId:
          type:
            - integer
            - 'null'
        updatedAt:
          format: date-time
          type:
            - string
            - 'null'
      required:
        - id
        - status
        - source
        - carrierName
        - countryCode
        - iccid
        - subscriptionId
        - deviceId
        - deviceUuid
        - msisdn
        - name
        - createdBy
        - networkStatus
        - createdAt
        - updatedAt
      type: object
    Pagination:
      properties:
        hasNext:
          type: boolean
        hasPrev:
          type: boolean
        page:
          minimum: 1
          type: integer
        pageSize:
          minimum: 1
          type: integer
        pages:
          minimum: 0
          type: integer
        total:
          minimum: 0
          type: integer
      required:
        - hasNext
        - hasPrev
        - page
        - pageSize
        - pages
        - total
      type: object
  securitySchemes:
    bearerAuth:
      bearerFormat: Opaque
      description: Bearer token via Authorization header
      scheme: bearer
      type: http

````